CREATE TABLE MESSAGE_DETAILS (	
  ID                    NUMBER NOT NULL,
  MESSAGE_ID            NUMBER NOT NULL,
  COMPONENT_IDENTIFIER  VARCHAR2(100 CHAR), 
  DETAIL_DATE           DATE   NOT NULL, 
  STATE                 VARCHAR2(8 CHAR) , 
  NODE                  VARCHAR2(128 CHAR), 
  PIPELINE_NAME         VARCHAR2(128 CHAR), 
  STAGE_NAME            VARCHAR2(128 CHAR), 
  INBOUND_SERVICE_NAME  VARCHAR2(256 CHAR), 
  INBOUND_SERVICE_URI   VARCHAR2(128 CHAR), 
  INBOUND_OPERATION     VARCHAR2(64 CHAR), 
  OUTBOUND_SERVICE_NAME VARCHAR2(256 CHAR), 
  OUTBOUND_SERVICE_URI  VARCHAR2(256 CHAR), 
  OUTBOUND_OPERATION    VARCHAR2(64 CHAR), 
  MSG_LABELS            VARCHAR2(2048 CHAR), 
  ERROR_CODE            VARCHAR2(64 CHAR), 
  ERROR_REASON          VARCHAR2(1024 CHAR), 
  ERROR_DETAILS         VARCHAR2(2048 CHAR), 
  PAYLOAD_STRING        CLOB,
  PAYLOAD_BINAIR        BLOB,
  CONSTRAINT MESSAGE_DETAILS_PK PRIMARY KEY (ID)
);

CREATE INDEX MESSAGE_DETAILS_MESSAGE_IDX ON MESSAGE_DETAILS (MESSAGE_ID) ;
CREATE SEQUENCE MESSAGE_DETAILS_SEQ INCREMENT BY 1 START WITH 1 MINVALUE 0 CACHE 20;

alter table MESSAGE_DETAILS add CONSTRAINT MESSAGE_DETAILS_MESSAGE_FK FOREIGN KEY ("MESSAGE_ID")
	  REFERENCES MESSAGE("ID") ON DELETE CASCADE;
